1#! /bin/sh
2#
3# Update a local Subversion, Git or Mercurial tree from the GCC
4# repository, with an emphasis on treating generated files correctly, so
5# that autoconf, gperf et al are not required for the ``end'' user.
6#
7# (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8# 2011 Free Software Foundation
9# Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10#
11# This script is Free Software, and it can be copied, distributed and
12# modified as defined in the GNU General Public License.  A copy of
13# its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14#
15#
16# By default all command-line options are passed to `svn update` or `hg/git
17# pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18# reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19# are omitted.
20#
21# If the first parameter reads --patch, the second parameter is considered
22# a patch file.
23#
24# If the first parameter is --touch, no svn operation will be performed,
25# only generated files that appear to be out of date in the local tree
26# will be touched.
27#
28# If the first parameter is --list, a list of the generated files and
29# their dependencies will be printed; --help prints this message.
30#
31# If the first parameter is --silent, this script prints nothing other
32# than error messages; the second parameter is then interpreted as above.
33#
34# Examples:
35#
36# contrib/gcc_update -r 8712
37# contrib/gcc_update --patch some-patch
38# contrib/gcc_update --touch
39# contrib/gcc_update --list
40
41
42# Default options used when updating (none).
43UPDATE_OPTIONS=""
44
45# Set the locale to C to make this script work for users with foreign
46# locale like e.g. French UTF-8.
47LANG=C
48LC_ALL=C
49export LANG LC_ALL
50
51######## Anything below shouldn't be changed by regular users.
52
53# Arrange for the value of $0 to be available for functions
54self=$0
55
56# This function prints its arguments to standard output unless
57# "silent" is set.
58unset silent
59chat () {
60    if [ -z "$silent" ]; then
61        echo "$@"
62    fi
63}
64
65# This function prints a list of all generated files, along with their
66# dependencies.  Note that only one target is supported per line: the
67# colon is stripped from the output.
68files_and_dependencies () {
69    sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70# fixincludes
71fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73# intl library
74intl/plural.c: intl/plural.y
75intl/configure: intl/configure.ac intl/aclocal.m4
76intl/config.h.in: intl/configure.ac intl/aclocal.m4
77# Now, proceed to gcc automatically generated files
78gcc/configure: gcc/configure.ac
79gcc/cstamp-h.in: gcc/configure.ac
80gcc/config.in: gcc/cstamp-h.in
81gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
83gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
84gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
85gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
86gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
87gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
88gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
89gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
90gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
91gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
92gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
93gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
95# And then, language-specific files
96gcc/cp/cfns.h: gcc/cp/cfns.gperf
97gcc/java/keyword.h: gcc/java/keyword.gperf
98# testsuite
99# Without this, _Pragma3.c can have a false negative.
100gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
101# Similarly, without this, you will see:
102# direct2s.c:35: warning: current file is older than direct2.c
103gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
104# lto-plugin
105lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
106lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
107# And libraries, at last
108libbanshee/configure: libbanshee/configure.ac
109libmudflap/configure: libmudflap/configure.ac
110libobjc/configure: libobjc/configure.ac
111zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
112zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
113zlib/configure: zlib/configure.ac zlib/aclocal.m4
114fastjar/aclocal.m4: fastjar/configure.ac
115fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
116fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
117boehm-gc/aclocal.m4: boehm-gc/configure.ac
118boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
119boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
120libada/configure: libada/configure.ac
121libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
122libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
123libffi/configure: libffi/configure.ac libffi/aclocal.m4
124libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
125libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
126libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
127libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
128libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
129libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
130libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
131libjava/aclocal.m4: libjava/configure.ac
132libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
133libjava/configure: libjava/configure.ac libjava/aclocal.m4
134libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
135libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
136libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
137libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
138libcpp/aclocal.m4: libcpp/configure.ac
139libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
140libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
141libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
142libgomp/Makefile.am: libgomp/plugin/Makefrag.am
143libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
144libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
145libgomp/configure.ac: libgomp/plugin/configfrag.ac
146libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
147libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
148libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
149libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
150libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
151libitm/configure: libitm/configure.ac libitm/aclocal.m4
152libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
153libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
154libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
155libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
156libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
157libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
158libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
159libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
160libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
161libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
162libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
163libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
164libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
165libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
166libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
167libcilkrts/aclocal.m4: libcilkrts/configure.ac
168libcilkrts/Makefile.in: libcilkrts/Makefile.am
169libcilkrts/configure: libcilkrts/configure.ac
170liboffloadmic/aclocal.m4: liboffloadmic/configure.ac
171liboffloadmic/Makefile.in: liboffloadmic/Makefile.am
172liboffloadmic/configure: liboffloadmic/configure.ac
173liboffloadmic/plugin/aclocal.m4: liboffloadmic/plugin/configure.ac
174liboffloadmic/plugin/Makefile.in: liboffloadmic/plugin/Makefile.am
175liboffloadmic/plugin/configure: liboffloadmic/plugin/configure.ac
176# Top level
177Makefile.in: Makefile.tpl Makefile.def
178configure: configure.ac config/acx.m4
179EOF
180}
181
182
183# This function touches generated files such that the ``end'' user does
184# not have to rebuild them.
185touch_files () {
186    rm -f Makefile.$$
187    echo 'all: \' > Makefile.$$
188    files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
189    echo '; @true' >> Makefile.$$
190    files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
191    files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
192    echo ':' >> Makefile.$$
193    echo '	@for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
194    echo '	echo Touching $@...; \' >> Makefile.$$
195    chat '	echo Touching $@... 1>&2; \' >> Makefile.$$
196    echo '	touch $@' >> Makefile.$$
197    files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
198
199    # We would have to explicitly shut off the "Entering... Leaving..."
200    # messages through "--no-print-directory" to handle the case when
201    # we were called from a recursive invocation (i.e. "$(MAKE)" in a
202    # Makefile, not just make).  Passing only "-s" doesn't help then,
203    # because make has helpfully added "-w" to MAKEFLAGS automatically.
204    # Unfortunately we do not require GNU make other than for building
205    # and testing, so let's just grep known text explicitly echoed by
206    # the rule.
207    while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
208      sleep 1
209    done 2>&1
210    rm -f Makefile.$$
211}
212
213
214# Whenever we update the tree or install a patch, we may be modifying
215# this script.  By re-execing it, we ensure that the appropriate
216# dependencies and rules will be used.
217touch_files_reexec () {
218    chat "Adjusting file timestamps"
219    exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
220}
221
222# This functions applies a patch to an existing tree.
223apply_patch () {
224    if [ -f "$1" ]; then
225	echo "Applying patch file $1"
226	case $1 in
227	*gz)
228	    gzip -d -c "$1" | patch -p1 ;;
229	*bz2)
230	    bzip2 -d -c "$1" | patch -p1 ;;
231	*)
232	    patch -p1 < "$1";;
233	esac
234    fi
235    touch_files_reexec
236}
237
238# Check whether this indeed looks like a local tree.
239if [ ! -f gcc/version.c ]; then
240    echo "This does not seem to be a GCC tree!"
241    exit
242fi
243
244case "$1" in
245--silent)
246    silent=t
247    shift
248    ;;
249esac
250
251case "$1" in
252# First of all, check whether we are going to process a patch.
253--patch)
254    if test "$#" != 2; then
255        echo "$1" expects only one argument >&2
256	exit 1
257    fi
258    apply_patch "${2}"
259    exit $?
260    ;;
261
262--touch)
263    if test "$#" != 1; then
264        echo "$1" does not expect any argument >&2
265	exit 1
266    fi
267    touch_files
268    exit $?
269    ;;
270
271--list)
272    if test "$#" != 1; then
273        echo "$1" does not expect any argument >&2
274	exit 1
275    fi
276    files_and_dependencies | sed 's/ /: /'
277    exit $?
278    ;;
279
280--help)
281    sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
282\
283
284p
285}' \
286	-e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
287    exit $?
288    ;;
289
290esac
291
292# Check for known version control systems.
293if [ -d .git ]; then
294    GCC_GIT=${GCC_GIT-${GIT-git}}
295    vcs_type="git"
296elif [ -d .hg ]; then
297    GCC_HG=${GCC_HG-${HG-hg}}
298    vcs_type="hg"
299elif [ -d .svn ]; then
300    GCC_SVN=${GCC_SVN-${SVN-svn}}
301    vcs_type="svn"
302else
303    echo "This does not seem to be a GCC GIT/HG/SVN tree!"
304    exit
305fi
306
307# Check command-line options
308if [ x"${1}"x = x"--nostdflags"x ]; then
309    shift
310else
311    set -- $UPDATE_OPTIONS ${1+"$@"}
312fi
313
314case $vcs_type in
315    git)
316	chat "Updating GIT tree"
317
318	$GCC_GIT diff --quiet --exit-code HEAD
319	if [ $? -ne 0 ]; then
320            echo "Attempting to update a dirty git tree!" >&2
321            echo "Commit or stash your changes first and retry." >&2
322            exit 1
323	fi
324
325	$GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
326	if [ $? -ne 0 ]; then
327            (touch_files_reexec)
328            echo "git pull of full tree failed." >&2
329            exit 1
330	fi
331
332	revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
333	branch=`$GCC_GIT name-rev --name-only HEAD || :`
334	;;    
335
336    hg)
337	chat "Updating HG tree"
338
339	# Add -q so untracked files aren't listed.
340	if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
341            echo "Attempting to update a dirty hg tree!" >&2
342            echo "Commit or revert your changes first and retry." >&2
343            exit 1
344	fi
345
346	# Check for mq extension.  mq patches must be popped so tip has
347	# been converted from the SVN tree.
348	if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
349	    # FIXME: Perhaps pop queue instead?  We could do that since we
350	    # know the tree is clean.
351	    echo "Attempting to update hg tree with mq patches applied!" >&2
352	    echo "Pop your patches first and retry." >&2
353	    exit 1
354	fi
355
356	# Update tree, but make sure to only pull the default branch.
357	# Otherwise all branches in the upstream repo are added, even if
358	# only a single one has been cloned.
359	$GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
360	if [ $? -ne 0 ]; then
361            (touch_files_reexec)
362            echo "hg pull of full tree failed." >&2
363            exit 1
364	fi
365
366	# Update tree.  Needs to be done separately from pull so
367	# gcc_update -rREV works.
368	$GCC_HG update ${silent+-q} ${1+"$@"}
369	if [ $? -ne 0 ]; then
370            (touch_files_reexec)
371            echo "hg update of full tree failed." >&2
372            exit 1
373	fi
374
375	# Extract SVN revision corresponding to parents, as stored by
376	# hg convert.  Before hg 1.4.3, there's no template keyword
377	# corresponding to the extra: tag, so need to use hg log --debug
378	# to extract the info.
379	parents=`$GCC_HG parents --template '{rev}'`
380	convert_revision=`$GCC_HG log --debug -r$parents | \
381	    sed -ne "/^extra:.*convert_revision=svn:/ {
382	        s%^[^/]*/%%
383		p
384	    }"`
385	revision=`echo $convert_revision | sed -e 's/.*@//'`
386	branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
387	;;
388
389    svn)
390	chat "Updating SVN tree"
391
392	$GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
393	if [ $? -ne 0 ]; then
394	    (touch_files_reexec)
395	    echo "SVN update of full tree failed." >&2
396	    exit 1
397	fi
398
399	revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
400	branch=`$GCC_SVN info | sed -ne "/^URL:/ {
401	    s,.*/trunk,trunk,
402	    s,.*/branches/,,
403	    s,.*/tags/,,
404	    p
405	}"`
406	;;
407esac
408
409rm -f LAST_UPDATED gcc/REVISION
410{
411    date
412    echo "`TZ=UTC date` (revision $revision)"
413} > LAST_UPDATED
414echo "[$branch revision $revision]" > gcc/REVISION
415
416touch_files_reexec
417